/***************************************************************************
                          nodewidget.h  -  description
                             -------------------
    begin                : Mon Jan 6 2003
    copyright            : (C) 2003 by Matt
    email                : mosixview@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NODEWIDGET_H
#define NODEWIDGET_H


#include <qwidget.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qdragobject.h>


#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <iostream>

using namespace std;


/**
  *@author Matt
  */

class nodewidget : public QLabel  {
   Q_OBJECT
public: 

// constructor
nodewidget::nodewidget(QWidget *parent, const char *name ) : QLabel(parent,name) {

  myname=name;
  QString nodetip;
  nodetip.sprintf("openMosix node %s", name);
  QToolTip::add(this, nodetip);

  // for drag + drop
  setAcceptDrops(true);

}

// destructor
nodewidget::~nodewidget(){
}


string nodewidget::getmyname() {
  return myname;
}

string int2string(const int i) {
  char buf[12];
  sprintf(buf,"%d",i);
  return(string(buf));
}


protected:


  virtual void dragEnterEvent(QDragEnterEvent *event) {
    if (QTextDrag::canDecode(event)) {
      event->accept();
    }
  }


  virtual void dropEvent(QDropEvent *event) {
    QString textdrop;
    if(QTextDrag::decode(event, textdrop)) {

      string mynodeID;
      mynodeID=this->getmyname();

      int migpid=textdrop.toInt();

      // prepare the cmdline
      string migcommand;
      migcommand.erase();
      migcommand = migcommand + "migrate ";
      migcommand = migcommand +  int2string(migpid);
      migcommand = migcommand + " ";
      migcommand = migcommand + mynodeID;

      cout << migcommand << endl;
      system(migcommand.c_str());

//      QWidget *tmpdel = event->source();
//      tmpdel->hide();

    }
  }


private:

  int ddButton;
  QPoint dragStartPos;

  string myname;


};

#endif
